import 'package:flutter/material.dart';

import '../../domain/models/Student.dart';

class DetailsPage extends StatelessWidget {
  final Student data;

  const DetailsPage(this.data, {super.key});

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: const EdgeInsets.only(bottom: 16.0),
            child: Image.network(
              data.image ?? '',
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(bottom: 4.0),
            child: Text(
              data.name,
              style: Theme.of(context).textTheme.headlineLarge,
            ),
          ),
          Text(
            Student.getYearWord(data.age),
            style: Theme.of(context).textTheme.bodyLarge,
          ),
          Text(
            'Courses: ${data.courses.join(", ")}',
            style: Theme.of(context).textTheme.bodyMedium,
          ),
        ],
      ),
    );
  }
}
